# coding: iso-8859-1

# Classe servant  grer les dossiers virtuels
#
# v1.0



class Virtual_Dir < Virtual_Object

  attr_accessor :children

  def initialize(name, parent=nil, contenu=nil)
    super

    @children = []
  end


  def self.from_path(path)
    arbo = path.split("/")
    first_folder = Virtual_Dir.new(arbo[0])
    folder = first_folder
    for i in 1...arbo.size
      old_folder = folder
      folder = Virtual_Dir.new(arbo[i], old_folder)
    end
    
    return folder
  end



  def self.folders_from_list(list)

    arbos = []
    for path in list
      arbo = path.split("/")
      arbos << arbo
    end

    hash = self.from_list_rec(arbos)

    #p hash
    arr = []
    for key, values in hash
      h = {}
      h[key] = values
      parent = Virtual_Dir.new(key)
      dir = Virtual_Dir.from_hash(h, parent)
      #p dir
      #dir.inspect2
      arr << dir
    end
    
    return arr
  end



  def self.from_list_rec(list)
    hash = {}
    for arbo in list
      if arbo.size > 1
        if hash[arbo[0]] == nil
          hash[arbo[0]] = []
        end
        arb = arbo[1...arbo.size]
        hash[arbo[0]] << arb
      else
        # C'est un fichier
        if hash[0] == nil
          hash[0] = []
        end
        hash[0] << arbo[0]
      end
    end



    for key, arbos in hash
      #p "key", key, arbos
      next if key == 0
      #gets
      rec = self.from_list_rec(arbos)
      hash[key] = rec if rec.size > 0

    end

    return hash
  end


  def self.from_hash(hash, parent)
    #p hash
    #gets

    for key, values in hash

      if key == 0
        for file_name in values
          file = Virtual_File.new(file_name)
          parent.add_child(file)
          file.parent = parent
        end
        next
      end

      dir = Virtual_Dir.new(key)
      dir.parent = parent
      parent.add_child(dir)
      Virtual_Dir.from_hash(values, dir)
    end

    return dir
  end


  def self.files_from_list(list)

    #files, folders = self.from_list(list)
    #return files
  end


  def self.from_list(list)


  end






  def fusion(dir)

  end








  def self.from_p(name, dir, contenu)
    # Repre s'il s'agit d'un chemin donn en entre
    if File.exists?(name)
      @dir = File.dirname(@name)
      path = @name.clone
      @name = File.basename(@name)
      # Si c'est un fichier
      if File.directory?(path) == false
        raise("Le nom donn en entre n'est pas celui d'un dossier.")
      else
        # Si c'est un dossier
        @contenu = {}
        add_entries(path)
      end
    end
  end
    

  def add_entries(name)
    entries = Dir.entries(name)-[".", "..", "Thumbs.db"]
    for entrie in entries
      file = Virtual_Object::dir_or_file(entrie, self)
      self.add_file(file)
    end
  end

  
  def add_file(file)
    @contenu.update({file.name => file})
  end

  def dir(name)
    return @contenu[name]
  end

  def file(name)
    return @contenu[name]
  end


  def inspect2(dec=0)
    puts " "*dec + "+" + @name
    for child in @children
      child.inspect2(dec+1)
    end

  end


  #########################################################
  # Patcheur
  #########################################################

  # Trouve tous les ajouts de fichiers faits entre les deux dossiers
  def ajout_nn(dir)
    ajout = dir.contenu - self.contenu
    return ajout
  end

  def modification_nn(dir)
    # On rcupre tous les fichiers communs
    common = dir.contenu.common(self.contenu)

  end

  def patcheur(dir)
    # On fait la liste de tous les fichiers
    alpha = self.entries_rec({}, 1..-1)
    beta = dir.entries_rec({}, 1..-1)



    #print Virtual_Object::inspect_list(alpha)
    puts ""
    #print Virtual_Object::inspect_list(beta)

    add = []
    mod = []
    delete = []

    # On supprime les fichiers communs aux deux rpertoires
    # On repre aussi les fichiers modifis et ajouts
    for path, f_alpha in alpha
      f_beta = beta[path]
      # On regarde si le fichier existe chez beta
      if f_beta != nil
        # Si le fichier n'a pas chang
        if f_alpha.contenu_r == f_beta.contenu_r
          alpha.delete(path)
          beta.delete(path)
        else
          mod << [f_beta.size, f_beta, f_beta.name]
          beta.delete(path)
        end
      else
        delete << [f_alpha.size, f_alpha, f_alpha.name]
      end
    end


    for path, f_beta in beta
      add << [f_beta.size, f_beta, f_beta.name]
    end

    add.sort!
    mod.sort!
    delete.sort!

    # On parcourt les fichiers effacs pour voir si par hasard
    # ils n'avaient pas t renomms
    index_add = 0
    index_mod = 0
    for taille, f_del in delete

      if add[index_add][0] > taille
        break
      end
      if add[index_add][0] < taille
        index_add += 1
        next
      end
      # Si on est ici, c'est que le fichier fait la mme taille

      

      #if mod[index_mod][0] < taille
      #  index_mod += 1
      #end
    end

    # On classe les fichiers par taille
    

    return add, mod, delete

  end

  def entries_rec(list={}, range=0..-1)
    for cle, cont in @contenu
      #list << cont
      list.update({cont.path(range) => cont})
      if cont.is_a?(Virtual_Dir) == true
        cont.entries_rec(list)
      end
    end
    return list
  end

  # Pour crire les fichiers sur le disque de faon temporaire,
  # puis faire un require
  def require
    
  end

end