
# Classe reprsentant une fausse map RM03.
# C'est l'quivalent dans le traitement d'une map RMXP.

module My_RPG


  class My_Map

    attr_accessor :contenu
    

    def affecter_rm03(contenu_fichier=nil, name=nil)
      @contenu = contenu_fichier
      @name = name.basename
    end

    def to_dmk_from_rm03

      if @contenu == nil
        raise("contenu vide pour map RM03")
      end
      @contenu_fichier = @contenu.clone
      
      #if @name != nil
      # Dtection du numro de la map
      map_numero = ((/(\d+)\.lmu$/.match(@name))[1]).to_i
      #end
      # On affecte le numro de la  map
      self.numero = map_numero


      # On spare le contenu de la map du reste
      contenu_map = separer_infos_map(@contenu, self)


      # On vrifie et on affecte certaines des valeurs de base
      if rm03_width.nil?
        @width = 20
      else
        @width = trouve_nombre(rm03_width, 0)
      end
      if @liste[3].nil?
        @height = 15
      else
        @height = trouve_nombre(rm03_height, 0)
      end



      # Traitement du tileset
      @data = self.traiter_tileset
      # Affectation d'un tileset
      @tileset_id = 1


      # On spare les events de la map
      separer_event(contenu_map, self)
  
      # On spare les instructions de la map
      fabriquer_commandes(self)

      
    end


    #def to_dmk
    #  return @map
    #end




    
    # Conversion au format RMXP
    def traiter_tileset
      # Couche Basse
      couche = self.liste[71]

      #p couche
      liste = []
      data = Table.new(self.width, self.height, 3)

      i = 0
      x = y = z = 0

      while i < couche.size
        nb = couche[i+1]*256+couche[i]


        if nb >= 5000 # Tileset
          nb -= 4616
          nb += ((nb-384)/6)*2
        elsif nb <= 4599
          if nb <= 2999 # Eau
            nb = nb%50+48
          elsif nb >= 4000 # Autotile
            nb -= 4000
            nb = ((nb / 50)+2)*48+nb%50
            #pa "auto", (nb / 50)
            # On regarde si le numro est jouable
            if nb > 7*50
              nb = 0
            end
          else # Eau Anime
            nb = 0
          end
        end

        data[x, y, z] = nb

        i += 2
        x += 1
        if x == self.width
          y += 1
          x = 0
        end

      end

      # Couche haute
      couche = self.liste[72]

      i = 0
      x = y = 0
      z = 1

      while i < couche.size
        nb = couche[i+1]*256+couche[i]
        #p nb
        #0/0 if gets.chop != ""

        dec = 192

        # Conversion au format RMXP
        # Couche basse
        nb -= 10000
        nb += 384+dec
        nb += ((nb-dec-384)/6)*2


        data[x, y, z] = nb

        i += 2
        x += 1
        if x == self.width
          y += 1
          x = 0
        end

      end

      return data

    end



    def rm03_width
      return @liste[2]
    end


    def rm03_height
      return @liste[3]
    end


    def rm03_couche_1
      self.liste[71]
    end


    def rm03_couche_2
      self.liste[72]
    end





    def separer_infos_map(contenu_map, map)
      @map_list = map.liste
      @pos = 0

      # Type de Map
      nom_type = trouve_av_prend(contenu_map)
      map.nom_type = nom_type

      # Numro info
      num_info = trouve_av_nombre(contenu_map)

      while (num_info != 0)

        #p num_info if $DEBUG
        #$liste.push(num_info) if $liste.include?(num_info) == false

        case num_info
        when 1 # Numro du chipset (par dfaut \001)
          #contenu = trouve_av_prend_nombre(contenu_map)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 2 # Largeur de la map
          #contenu = trouve_av_prend_nombre(contenu_map)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 3 # Hauteur de la map
          #contenu = trouve_av_prend_nombre(contenu_map)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 11 # Rptition de la carte (de \000  \003)
          #contenu = trouve_av_prend_nombre(contenu_map)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 31 # Indique qu'il y a un arrire-plan
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 32 # Nom de l'arrire-plan
          #pa "pano", contenu_map[@pos..@pos+50]
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
          map.panorama_name = contenu
        when 33 # Dfilement horizontal (ON)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 34 # Dfilement vertical (ON)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 35 # Auto-dfilement horizontal (ON)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 36 # Vitesse auto-dfilement horizontal (-8  +8)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 37 # Auto-dfilement vertical (ON)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 38 # Vitesse auto-dfilement vertical (-8  +8)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 40 # INCONNU
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 41 # Paramtres de la gnration
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 42 # Gnre un nouveau donjon  chaque chargement de la map (0 : activation)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 48 # Taille des passages (2x2)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 49 # Largeur de la salle
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 50 # Hauteur de la salle
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 51 # Recouvrir les alentours de la carte par des murs (OFF)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 52 # INCONNU
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 53 # Sol B (OFF)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 54 # Sol C (OFF)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 55 # Obstacle B (OFF)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 56 # Obstacle C (OFF)
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 60 # INCONNU
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 61 # INCONNU
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 62 # INCONNU
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 71 # Couche Basse
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 72 # Couche Haute
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        when 81 # contenu des events
          contenu_q = trouve_av_prend(contenu_map)
        when 91 # nombre de modifications
          contenu = trouve_av_prend(contenu_map)
          ajouter_map_list(num_info, contenu)
        else
          p "map num_info inconnu : #{num_info}"
          0/0
        end



        num_info = trouve_av_nombre(contenu_map)

      end


      return contenu_q

    end




    def ajouter_map_list(num_info, contenu)
      @map_list.update({num_info => contenu})
    end






    def separer_event(contenu_map, map)

      @pos = 0
      nb_events = trouve_av_nombre(contenu_map)


      for i in 0...nb_events

        event = My_RPG::My_Event.new(-1, -1)
        # On affecte la map
        event.map = map
        event.liste = {}

        # on prend le numro de l'event
        event_numero = trouve_av_nombre(contenu_map)
        event.numero = event_numero

        pp1 = @pos
        # on prend le numro de la partie
        num_part = trouve_av_nombre(contenu_map)
        pp2 = @pos

        #puts "event : #{event.numero}"

        while (num_part != 0)

          #puts "  num_part : #{num_part}"

          case num_part
          when 1 # nom de l'event
            info = prendre_info_ansi(contenu_map)
            event.liste.update({num_part => info})
            event.name = info
          when 2 # coordonne X
            info = prendre_info_ansi(contenu_map)
            event.liste.update({num_part => info})
            event.x = trouve_nombre(info, 0)
          when 3 # coordonne Y
            info = prendre_info_ansi(contenu_map)
            event.liste.update({num_part => info})
            event.y = trouve_nombre(info, 0)
          when 5 # Pages
            info = prendre_info_ansi(contenu_map)
            pp = @pos
            # On spare le contenu des pages
            separer_pages(info, event)
            @pos = pp
            #event.liste.update({num_part => lis})
          else
            p "code inconnu1 : "+contenu_map[pp1...pp2]+"  "+num_part.to_s
            $contenu_map = contenu_map
            0/0
          end


          pp1 = @pos
          # on prend le numro de la partie
          num_part =  trouve_av_nombre(contenu_map)
          pp2 = @pos

        end

        # Pour prendre en compte la non affectation des valeurs par dfaut
        event.x = 0 if event.x == -1
        event.y = 0 if event.y == -1


        #event.name = event.liste[1]
        #event.numero = event.liste[0]
        #$event = event if $event.nil?

        # Ajout d'un event dans la map
        map.events.update({event.numero => event})


      end


    end



    def separer_pages(contenu_5, event)

      @pos = 0

      # on prend le nombre de pages
      nb_pages = trouve_av_nombre(contenu_5)
      #@pos += 1


      for i in 0...nb_pages

        # on prend le numro de la page
        num_page = trouve_av_nombre(contenu_5)
        page = My_RPG::My_Page.new(i)
        event.pages.push(page)

        # On affecte l'event  la page
        page.event = event

        # on affecte le numro de la page
        page.numero = num_page

        pp1 = @pos
        # on prend le numro de la partie
        num_part = trouve_av_nombre(contenu_5)
        pp2 = @pos

        #puts "      page : #{i}"

        while (num_part != 0)

          #puts "        code : #{num_part}"

          case num_part
          when 1 # INCONNU
            info = contenu_5[@pos+1..@pos+1]
            @pos += 1
            page.liste.update({num_part => info})
          when 2 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 21 # Nom du charset
            info = prendre_info_ansi(contenu_5)
=begin
        if info.include?("\351")
        #if info == "fum\351e"
          $infos[info] = 0 if $infos[info] == nil
          $infos[info] = $infos[info]+1
          info_s = info.clone
          info.gsub!("\351", "e")
          print "\n#{info} : "+$infos[info_s].to_s
        end
        if info == "testtest"
          info = "pjs"
        end
=end
            page.liste.update({num_part => info})
          when 22 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 23 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 24 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 32 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 37 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 25 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 31 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 33 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 34 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 35 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 36 # INCONNU
            info = prendre_info_ansi(contenu_5)
            page.liste.update({num_part => info})
          when 41 # INCONNU
            info = prendre_info_ansi(contenu_5)
            #print "#{event.numero} #{event.pages.size-1} : "; p contenu_5[@pos..@pos+info.size+10]
            #print "info : "; p info; puts "\n"
            page.liste.update({num_part => info})
          when 51 # Premire taille de la page
            info = prendre_info_ansi(contenu_5)
            # On ne l'enregistre pas
            #### page.liste.update({num_part => info})
          when 52 # Deuxime taille de la page
            info = prendre_info_ansi(contenu_5)
            #@pos = pp
            #p1 = @pos
            #taille_page = trouve_av_nombre(contenu_5)
            #taille_sz = @pos-p1
            #puts "taille "+taille_sz.to_s
            #taille_page = trouve_av_nombre(contenu_5)
            #info = contenu_5[@pos..@pos+taille_page]
            #@pos += taille_sz
            page.liste.update({num_part => info})
            #puts @pos.to_s+"  "+contenu_5.size.to_s
            #if @pos == contenu_5.size then return end
            #when 99 #
            #    info = prendre_info_ansi(contenu_5)
            #    liste.update({num_part => info})

          else

            p "code inconnu2 : "+contenu_5[pp1...pp2]+"  "+num_part.to_s
            p prendre_info_ansi(contenu_5)
            $contenu_5 = contenu_5
            0/0
          end

          pp1 = @pos
          # on prend le numro de la partie
          num_part =  trouve_av_nombre(contenu_5)
          pp2 = @pos

        end

      end
    end



    def separer_instructions(contenu_page, page)

      @page = page
      @pos = 0

      @instr = []

      #(contenu_page.scan /.{7}/).each{|x| p x}

      #@nb = 0

      #p contenu_page

      while (@pos < contenu_page.size)
        #p "- "+@nb.to_s
        instr = extraire_instruction(contenu_page)
        instr.page = @page
        @page.instructions.push(instr)
        @page.add_indent(instr, @ind)
        #pa instr.class, @ind, instr.indent
        #@nb += 1
      end

      # On supprime la dernire instruction (fin de la page)
      #@page.instructions.pop

    end


    def extraire_instruction(contenu_page)
      pp1 = @pos
      #p contenu_page[@pos..@pos+100]
      # on prend le numro de l'instruction
      num_instr =  trouve_av_nombre(contenu_page)
      pp2 = @pos

      indent =  trouve_av_nombre_inf(contenu_page)
      @ind = indent

      puts "          num_instr : #{num_instr}" if $DEBUG
      #$liste.push(num_instr) if $liste.include?(num_instr) == false

      #p num_instr


      case num_instr

      when 0 # Fin de la page
        @pos += 3
        #p @pos, contenu_page.size
        return My_RPG::My_Command_Page_End.new

      when 10 # ligne vide
        #p contenu_page[@pos..@pos+10]
        @pos += 2
        return My_RPG::My_Command_Line_Empty.new

      when 1008 # Changer la classe d'un hros
      when 1009 # Changer les commandes de combat

      when CODE_MESSAGE_RM03 # 10110 : Message
        info1 = prendre_info_ansi(contenu_page)
        @pos += 1
        return My_RPG::My_Command_Message.from_rm03(info1)
        #return creer_commande(num_instr, indent, info1, "")

      when 10120 # Options d'affichage des messages
      when CODE_MESSAGE_FACE # 10120 : Options d'affichage des visages
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        #$test = [num_instr, indent, [info1, info2]]
        return My_RPG::My_Command_Message_Face.from_rm03(indent, info1, info2)


      when 10140 # Proposer un choix XP (+-)
        info1 = prendre_info_ansi(contenu_page)
        info1 = info1.split("/") # DANGER foireux
        info2 = convertir_nombre(prendre_info(contenu_page))
        #p "choix : ",info1, info2
        return My_RPG::My_Command_Slot.new(indent, [info1, info2])

      when CODE_NUMBER_INPUT_RM03 # 10150 : Entrer un nombre

        info1 = prendre_info(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Number_Input.from_rm03(indent, info2)

      when 10210 # Modifier interrupteur(s)
      when 10220 # Modifier une variable
      when 10230 # Modifier Chrono
      when 10310 # Ajouter / Retirer Monnaie
      when 10320 # Ajouter / Retirer Objet(s)
      when 10330 # Modifier l'quipe
      when 10410 # Modifier points d'exprience
      when 10420 # Modifier le niveau
      when 10430 # Modifier caractristiques de base
      when 10440 # Ajouter / Retirer une comptence
      when 10450 # Modifier l'quipement
      when 10460 # Modifier les HP
      when 10470 # Modifier les MP
      when 10480 # Modifier le statut
      when 10490 # Soigner compltement
      when 10500 # Simuler une attaque ennemie


      when 10610 # Modifier le nom d'un hros XP
        info1 = prendre_info_ansi(contenu_page) # Nom du hros
        info2 = prendre_info(contenu_page) # Id du hros
        return My_RPG::My_Command_Change_Name.from_rm03(indent, info1, info2)

      when 10620 # Modifier le grade d'un hros
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


      when 10630 # Modifier l'apparence d'un hros
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])

      when 10640 # Modifier le visage d'un hros
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])



      when 10650 # Modifier l'apparence du vhicule
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


      when 10660 # Modifier une musique
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


      when 10670 # Modifier un effet sonore
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


      when 10680 # Modifier l'apparence du systme
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


      when 10690 # Dfinir les transitions

      when 10710 # Dmarrer combat
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])

      when 10720 # Appeler un magasin
      when 10730 # Appeler une auberge
      when 10740 # Entrer le nom d'un hros
      when 10810 # Tlporter l'quipe
      when 10820 # Mmoriser la position
      when 10830 # Retour  la position mmorise
      when 10840 # Entrer / Sortir d'un vhicule
      when 10850 # Dfinir la position d'un vhicule
      when 10860 # Modifier position d'un vnement
      when 10870 # Inverser position de 2 vnements
      when 10910 # Stocker l'id d'un terrain
      when 10920 # Stocker l'ID d'un vnement
      when CODE_SCREEN_ERASE_RM03 # 11010 : Effacer l'cran
        info1 = prendre_info(contenu_page)
        transition = prendre_info(contenu_page)
        return My_RPG::My_Command_Screen_Erase.from_rm03(transition)
      when 11020 # Faire apparatre l'cran
      when 11030 # Modifier le ton de l'cran
      when 11040 # Flasher l'cran
      when 11050 # Faire trembler l'cran
      when 11060 # Options de dfilement de l'cran
      when 11070 # Effets mtorologiques


      when 11110 # Afficher une image
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])
      when 11120 # Dplacer une image
      when 11130 # Effacer une image
      when 11210 # Afficher une animation de combat
      when 11310 # Modifier la transparence du hros
      when 11320 # Flasher un vnement ou un hros
      when 11330 # Dplacer / Modifier un vnement
      when 11340 # Dplacer tous les vnements
      when 11350 # Stopper tous les vnements

      when 11410 # Attendre
        # DOC
        # info1 : rien
        # info2 : temps (en diximes de seconde) | touche presse (\000 = false ou \001 = true)
        # La touche presse n'est prsente que si elle a dj t renseigne
        @pos += 1
        info2 = prendre_info(contenu_page)
        temps = trouve_nombre(info2, 0)
        # On regarde si on est arriv  la fin de la string
        #pa @plus_pos, info2.size
        if @plus_pos < info2.size
          touche = (info2[info2.size-1] != 0)
        else # il faut donner la valeur par dfaut
          #touche = false
          # DEFAUT
          touche = -1
        end

        #pa "touche", touche, temps
        return My_RPG::My_Command_Wait.new(temps*2, touche)

      when 11510 # Jouer une musique
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])

      when 11520 # "Faire disparatre" la musique
      when 11530 # Mmoriser une musique
      when 11540 # Jouer une musique mmorise


      when 11550 # Jouer un effet sonore
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])

      when 11560 # Jouer un film
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])
      when 11610 # Demander l'appui d'une touche
      when 11710 # Modifier le chipset de la carte

      when 11720 # Modifier l'arrire-plan
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])
      when 11740 # Modifier le taux de rencontre
      when 11750 # Modifier un carreau
      when 11810 # Gestion des points de tlportation
      when 11820 # Autoriser / Interdire tlportation
      when 11830 # Dfinir le point de fuite
      when 11840 # Autoriser / Interdire fuite
      when 11910 # Ouvrir le menu de sauvegarde
      when 11930 # Autoriser/Interdire la sauvegarde
        @pos += 1
        info2 = prendre_info(contenu_page)
        #return creer_commande(num_instr, indent, "", info2)
        return My_RPG::My_Command_Save_Authorize.from_rm03(indent, info2)
      when 11950 # Ouvrir le menu
      when 11960 # Autoriser / Interdire menu
      when 12010 # Condition


      when 12110 # Mettre une tiquette
        #p contenu_page[@pos..@pos+10]
        @pos += 1
        nom = prendre_info(contenu_page)
        return My_RPG::My_Command_Sticker.from_rm03(indent, nom)

      when 12120 # Aller  une tiquette
        @pos += 1
        info2 = prendre_info(contenu_page).to_s
        return My_RPG::My_Command_Sticker_End.from_rm03(indent, info2)

      when 12210 # Boucle
        @pos += 2
        return My_RPG::My_Command_Loop.new
      when 12220 # Sortir de la boucle
        @pos += 2
        return My_RPG::My_Command_Loop_Break.new

      when 12310 # Stopper cet vnement
      when 12320 # Effacer cet vnement
        @pos += 2
        return My_RPG::My_Command_Event_Delete.new
      when 12330 # Appeler un vnement


      when 12410 # Commentaire
        info1 = prendre_info_ansi(contenu_page)
        @pos += 1
        return My_RPG::My_Command_Commentary.from_rm03(info1)
        #return creer_commande(num_instr, indent, info1, "")

      when CODE_GAME_OVER_RM03 # 12420 : Fin du jeu
        @pos += 2
        return My_RPG::My_Command_Game_Over.from_rm03(indent)
        #return creer_commande(num_instr, indent, "", "")

      when CODE_TITLE_RM03 # 12510 : Retour  l'cran titre
        @pos += 2
        return My_RPG::My_Command_Title.from_rm03(indent)

      when CODE_MESSAGE_SUITE_RM03 # 20110 : suite de message
        info1 = prendre_info_ansi(contenu_page)
        @pos += 1
        return My_RPG::My_Command_Message_Suite.from_rm03(info1)
        #return creer_commande(num_instr, indent, info1, "")

      when 20140 # suite de Proposer un choix
        info1 = prendre_info_ansi(contenu_page)
        info2 = convertir_nombre(prendre_info(contenu_page))
        #puts "suite : "+info1
        #gets
        return My_RPG::My_Command_Slot_Suite.new(indent, [info2, info1])

      when 20141 # suite de Proposer un choix (fin)
        @pos += 2
        return My_RPG::My_Command_Slot_Fin.new(indent)

      when 20710 # INCONNU
      when 20711 # INCONNU
      when 20712 # INCONNU
      when 20713 # INCONNU
      when 20720 # INCONNU
      when 20721 # INCONNU
      when 20722 # INCONNU
      when 20730 # INCONNU
      when 20731 # INCONNU
      when 20732 # INCONNU


      when 22010 # ouverture de Conditions


      when 22011 # Conditions (fin)

      when 22210 # Boucle (fin)
        @pos += 2
        return My_RPG::My_Command_Loop_End.new

      when 22410 # Deuxime ligne de commentaires
        info1 = prendre_info_ansi(contenu_page)
        info2 = prendre_info(contenu_page)
        return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])







      else
        p "instruction code inconnu : "+contenu_page[pp1...pp2]+"  "+num_instr.to_s
        $page = contenu_page
        0/0





      end


      info1 = prendre_info(contenu_page)
      info2 = prendre_info(contenu_page)
      #p [num_instr, indent, [info1, info2]]

      return My_RPG::My_Command_Non_Traite.new(num_instr, indent, [info1, info2])


    end








  end
end

=begin


    def to_rmxp_from_dmk
      self.panorama_name = "005-Sunset01.jpg"


      map = RPG::Map.new(self.width, self.height)
      #map.numero = 2
      # Traitement du tileset
      map.data = self.traiter_tileset
      # Affectation d'un tileset
      map.tileset_id = 51
      # Affectation du panorama
      #map.panorama_name = self.panorama_name
      # Traitement des events
      map.events = self.traiter_event


      return map

    end


    def traiter_event
      events = {}
      for num, event in @events
        events[num] = event.to_rmxp
        #p events[num]
        #print event.x, " ", event.y, "\n"
      end

      return events
    end

    def ==(map_rm03)
      raise("pas bon")
      return super if self.class != map_rm03.class
      if @contenu_fichier != map_rm03.contenu_fichier
        raise(DMKW_DMK_Diff.new("file != content"))
      end
      return true
    end


=end
